//+------------------------------------------------------------------+
//|                                                    TSR_M1_MR.mq4 |
//|                                    Copyright  2007, Petr Kouril |
//|                                           http://www.jaktrade.cz |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007, Petr Kouril"
#property link      "http://www.jaktrade.cz"

// Needed Custom Indicator

#property indicator_separate_window
#property indicator_minimum  0
#property indicator_maximum  1
#property indicator_buffers  4
#property indicator_color1 Red
#property indicator_color2 Lime
#property indicator_color3 Yellow
#property indicator_color4 RoyalBlue

//---- input parameters
extern int					TimeFrame 		  = 1;
extern bool					AlertPossible    = true;
extern bool					SendMailPossible = true;

int							LastAlertTime    = 0;

//---- buffers
double EnterLong[];
double EnterShort[];
double EnterNothing[];
double EnterPossible[];

int init()
{
	IndicatorBuffers(4);
	
	SetIndexStyle (0, DRAW_HISTOGRAM, EMPTY, 3);
   SetIndexBuffer(0, EnterShort);

	SetIndexStyle (1, DRAW_HISTOGRAM, EMPTY, 3);
   SetIndexBuffer(1, EnterLong);

	SetIndexStyle (2, DRAW_HISTOGRAM, EMPTY, 3);
   SetIndexBuffer(2, EnterNothing);

	SetIndexStyle (3, DRAW_HISTOGRAM, EMPTY, 3);
   SetIndexBuffer(3, EnterPossible);
   
   return(0);
}

int deinit()
{
   return(0);
}

int start()
{
	int limit, LastLong = -1, LastShort = -1;
	double Long, Short, Nothing, MT300, MT400, CloseValue;
	
   int counted_bars = IndicatorCounted();
   if (counted_bars<0) return(-1);
   if (counted_bars>0) counted_bars--;
   limit = Bars-counted_bars;

	for (int i = limit-1; i >= 0; i--)
	{
   	GetShortLong(Long, Short, Nothing, MT300, MT400, i);
		if (Long != EMPTY_VALUE)
		{
	   	EnterShort[i]   = EMPTY_VALUE;
   		EnterLong[i]    = 1;
   		
	   	if (EnterLong[i+1] != EMPTY_VALUE)
	   		EnterNothing[i] = EMPTY_VALUE;
	   	else
	   	{
	   		EnterNothing[i] = 1;
	   		MakeAlert(Symbol() + " M1 Long Market Rotation", i);
	   	}
	   	
	   	LastLong  = i;
	   	LastShort = EMPTY_VALUE;
		}	
		if (Short != EMPTY_VALUE)
		{
	   	EnterLong[i]    = EMPTY_VALUE;
	   	EnterShort[i]   = 1;
	   	
	   	if (EnterShort[i+1] != EMPTY_VALUE)
	   		EnterNothing[i] = EMPTY_VALUE;
	   	else
	   	{
	   		EnterNothing[i] = 1;
	   		MakeAlert(Symbol() + " M1 Short Market Rotation", i);
	   	}
	   	
	   	LastLong  = EMPTY_VALUE;
	   	LastShort = i;
		}	
		if (Nothing != EMPTY_VALUE)
		{
//			if (LastLong != 0)
			if (EnterLong[i+1] != EMPTY_VALUE)
			{
	   		EnterLong[i]    = 0.5;
	   		EnterShort[i]   = EMPTY_VALUE;
	   		EnterNothing[i] = EMPTY_VALUE;
			}	
//			if (LastShort != 0)
			if (EnterShort[i+1] != EMPTY_VALUE)
			{
	   		EnterLong[i]    = EMPTY_VALUE;
	   		EnterShort[i]   = 0.5;
	   		EnterNothing[i] = EMPTY_VALUE;
	   	}
		}

		EnterPossible[i] = EMPTY_VALUE;
		if ((EnterLong[i] != EMPTY_VALUE) && (MT400 != EMPTY_VALUE) && (MT300 != EMPTY_VALUE))
		{
			CloseValue = iLow(NULL, TimeFrame, i);
			if ((CloseValue < MT300) || (CloseValue < MT400))
				EnterPossible[i] = 0.15;			
			if ((CloseValue < MT300) && (CloseValue < MT400))
				EnterPossible[i] = 0.30;			
		}
		if (EnterShort[i] != EMPTY_VALUE)
		{
			CloseValue = iHigh(NULL, TimeFrame, i);
			MT400 = iCustom(NULL, TimeFrame, "Mega trend", 400, 3, 0, 1, i);
			MT300 = iCustom(NULL, TimeFrame, "Mega trend", 300, 3, 0, 1, i);
			if ((MT400 != EMPTY_VALUE) && (MT300 != EMPTY_VALUE))
			{
				if ((CloseValue > MT300) || (CloseValue > MT400))
					EnterPossible[i] = 0.15;			
				if ((CloseValue > MT300) && (CloseValue > MT400))
					EnterPossible[i] = 0.30;			
			}
		}
	}   
   return(0);
}

void GetShortLong(double &Long, double &Short, double &Nothing, double &MT300, double &MT400, int i)
{
	double BT240, BT120, SL60, SL80, CloseValue;
	
	MT400 = iCustom(NULL, TimeFrame, "Mega trend", 				400, 3, 0, 0, i);
	MT300 = iCustom(NULL, TimeFrame, "Mega trend", 				300, 3, 0, 0, i);
	BT240 = iCustom(NULL, TimeFrame, "Big trend",  				240, 3, 0, 0, i);
	BT120 = iCustom(NULL, TimeFrame, "Big trend",  				120, 3, 0, 0, i);
	SL60  = iCustom(NULL, TimeFrame, "Slope Direction Line",  60, 3, 0, 0, i);
	SL80  = iCustom(NULL, TimeFrame, "Slope Direction Line",  80, 3, 0, 0, i);
	
	if ((MT400 != EMPTY_VALUE) && (MT300 != EMPTY_VALUE) && (BT240 != EMPTY_VALUE) && (BT120 != EMPTY_VALUE) && (SL60 != EMPTY_VALUE) && (SL80 != EMPTY_VALUE))
	{
		Short = EMPTY_VALUE; Long = 1; Nothing = EMPTY_VALUE;
		return;
	}

	if ((MT400 == EMPTY_VALUE) && (MT300 == EMPTY_VALUE) && (BT240 == EMPTY_VALUE) && (BT120 == EMPTY_VALUE) && (SL60 == EMPTY_VALUE) && (SL80 == EMPTY_VALUE))
	{
		Short = 1; Long = EMPTY_VALUE; Nothing = EMPTY_VALUE;
		return;
	}
		
	Short = EMPTY_VALUE; Long = EMPTY_VALUE; Nothing = 1;
}


void MakeAlert(string Notice, int Index)
{
	datetime AlertTimeOut = iTime(NULL, 0, 1) - iTime(NULL, 0, 2);
	
	if (Index >= 2) return;
	if ((TimeCurrent() - LastAlertTime) < AlertTimeOut) return;

	if (AlertPossible)    {PlaySound("alert2.wav"); Alert(Notice);}
	if (SendMailPossible) SendMail(Notice, "");
	LastAlertTime = TimeCurrent();
}

